'============= START FONT BUSINESS ==========================
Function Blur(Byref tim As Uinteger Pointer,rad As Single=2) As Uinteger Pointer
    Type p2
        As Integer x,y
        As Uinteger col
    End Type
    #macro ppoint(_x,_y,colour)
    pixel=row+pitch*(_y)+4*(_x)
    (colour)=*pixel
    #endmacro
    #macro ppset(_x,_y,colour)
    pixel=row+pitch*(_y)+4*(_x)
    *pixel=(colour)
    #endmacro
    #macro average()
    ar=0:ag=0:ab=0:inc=0
    xmin=x:If xmin>rad Then xmin=rad
    xmax=rad:If x>=(_x-1-rad) Then xmax=_x-1-x
    ymin=y:If ymin>rad Then ymin=rad
    ymax=rad:If y>=(_y-1-rad) Then ymax=_y-1-y
    For y1 As Integer=-ymin To ymax
        For x1 As Integer=-xmin To xmax
            inc=inc+1 
            ar=ar+(NewPoints(x+x1,y+y1).col Shr 16 And 255)
            ag=ag+(NewPoints(x+x1,y+y1).col Shr 8 And 255)
            ab=ab+(NewPoints(x+x1,y+y1).col And 255)
        Next x1
    Next y1
    averagecolour=Rgb(ar/(inc),ag/(inc),ab/(inc))
    #endmacro
    Dim As Integer _x,_y
    Imageinfo tim,_x,_y
    Dim  As Uinteger Pointer im=Imagecreate(_x,_y)
    Dim As Integer pitch
    Dim  As Any Pointer row
    Dim As Uinteger Pointer pixel
    Dim As Uinteger col
    Imageinfo tim,,,,pitch,row
    Dim As p2 NewPoints(_x,_y)
    For y As Integer=0 To (_y)-1
        For x As Integer=0 To (_x)-1
            ppoint(x,y,col)
            NewPoints(x,y)=type<p2>(x,y,col)
        Next x
    Next y
    Dim As Uinteger averagecolour
    Dim As Integer ar,ag,ab
    Dim As Integer xmin,xmax,ymin,ymax,inc
    For y As Integer=0 To _y-1
        For x As Integer=0 To _x-1  
            average()
            NewPoints(x,y).col=averagecolour
        Next x
    Next y
    Imageinfo im,,,,pitch,row
    For y As Integer=0 To _y
        For x As Integer=0 To _x
            ppset((NewPoints(x,y).x),(NewPoints(x,y).y),NewPoints(x,y).col) 
        Next x
    Next y
    ImageDestroy tim: tim = 0
    Function= im
End Function
Sub drawstring(xpos As Integer,ypos As Integer,text As String,colour As Uinteger,size As Single,im As Any Pointer=0)
    Type D2
        As Double x,y
        As Uinteger col
    End Type
    Static As d2 cpt(),XY()
    Static As Integer runflag
    If runflag=0 Then   
        Redim  XY(64,127)
        Redim cpt(1 To 64)
        Screenres 10,10  
        dim as uinteger pointer img
        Dim count As Integer
        For ch As Integer=1 To 127
            img=imagecreate(10,10)
            Draw String img,(1,1),Chr(ch)
            For x As Integer=1 To 8  
                For y As Integer=1 To 8
                    If Point(x,y,img)<>0 Then
                        count=count+1
                        XY(count,ch)=Type<D2>(x,y)
                    End If 
                Next y
            Next x
            count=0
            imagedestroy img
        Next ch
        runflag=1 
    End If
    If size=0 Then Exit Sub
    Dim As D2 np,t
    #macro Scale(p1,p2,d)
    np.col=p2.col
    np.x=d*(p2.x-p1.x)+p1.x
    np.y=d*(p2.y-p1.y)+p1.y
    #endmacro
    
    Dim As D2 c=Type<D2>(xpos,ypos)
    Dim As Integer dx=xpos,dy=ypos
    For z6 As Integer=1 To Len(text)
        Var asci=text[z6-1]
        For _x1 As Integer=1 To 64
            t=Type<D2>(XY(_x1,asci).x+dx,XY(_x1,asci).y+dy,colour)         
            Scale(c,t,size)
            cpt(_x1)=np
            
            If XY(_x1,asci).x<>0 Then 
                If Abs(size)>1 Then
                    Line im,(cpt(_x1).x-size/2,cpt(_x1).y-size/2)-(cpt(_x1).x+size/2,cpt(_x1).y+size/2),cpt(_x1).col,bf
                Else
                    Pset im,(cpt(_x1).x,cpt(_x1).y),cpt(_x1).col
                End If
            End If
        Next _x1
        dx=dx+8
    Next z6 
End Sub
Sub init Constructor 'automatic loader
    drawstring(0,0,"",0,0)
    Screen 0
End Sub

function Colour(im as uinteger pointer,newcol as uinteger,grade as integer) as uinteger pointer
    #macro ppset2(_x,_y,colour)
    pixel2=row2+pitch2*(_y)+4*(_x)
    *pixel2=(colour)
    #endmacro
    #macro ppoint(_x,_y,colour)
    pixel=row+pitch*(_y)+4*(_x)
    (colour)=*pixel
    #endmacro
    dim as integer w,h
    Dim As Integer pitch,pitch2
    Dim  As Any Pointer row,row2
    Dim As Uinteger Pointer pixel,pixel2
    Dim As Uinteger col
    Imageinfo im,w,h,,pitch,row
    dim as uinteger pointer temp
    temp=imagecreate(w,h)
    Imageinfo temp,,,,pitch2,row2
    for y as integer=0 to h-1
        for x as integer=0 to w-1
            ppoint(x,y,col)
         Var v=.299*((col Shr 16)And 255)+.587*((col Shr 8)And 255)+.114*(col And 255)
         if v>grade then 
       ppset2(x,y,newcol)
       else
       ppset2(x,y,rgb(255,0,255))
      end if
        next x
    next y
    return temp
    end function

sub FONT(byref myfont as uinteger pointer,fontsize as integer,col as uinteger,grade as integer=190)
Const FIRSTCHAR = 32, LASTCHAR = 127
Const NUMCHARS = (LASTCHAR - FIRSTCHAR) + 1
Dim As ubyte Ptr p
dim as uinteger pointer temp
Dim As Integer i
temp = ImageCreate(NUMCHARS * 8*FontSize, 9*FontSize,rgb(255,0,255))
myfont=ImageCreate(NUMCHARS * 8*FontSize, 9*FontSize,rgb(255,0,255))

For i = FIRSTCHAR To LASTCHAR
    drawstring ((i - FIRSTCHAR) * 8*FontSize, 1,chr(i),rgb(255,255,255),FontSize,temp)
Next i
for n as integer=1 to fontsize-1
    temp=blur(temp,1)
next n
temp=Colour(temp,col,grade)
put myfont,(0,0),temp,trans
ImageInfo( myfont,,,,, p )
p[0] = 0
p[1] = FIRSTCHAR
p[2] = LASTCHAR
For i = FIRSTCHAR To LASTCHAR
    p[3 + i - FIRSTCHAR] = 8*FontSize
next i
imagedestroy(temp)
end sub 
'=================== END FONTS ========================================


'===========  USAGE ========================
screen 19,32

dim as uinteger pointer customfont
dim as uinteger pointer customfont2
dim as uinteger pointer customfont3

'font choice,size,colour

font customfont,3,rgb(0,200,0)


'You can tweak the last parameter a bit.
'The default is 190
font customfont2,1,rgb(200,200,200),205


font customfont3,4,rgb(0,0,255),210


draw string(50,50),"Custom font",,customfont
draw string(50,200),"Custom font2",,customfont2
draw string(50,300),"Custom font3",,customfont3
draw string(50,400),"Press a key",,customfont

sleep
do
    screenlock
    cls
    draw string(10,200),"Once the fonts are created then",,customfont
    draw string(10,300),"they display by Draw string.",,customfont
    draw string(10,400),"<ESC> to end",,customfont3
    screenunlock
    sleep 1,1
    loop until inkey=chr(27)


 